local MakePlayerCharacter = require "prefabs/player_common"

local assets = {
Asset( "ANIM", "anim/vader.zip"),
Asset( "ANIM", "anim/vader_crown.zip"),
Asset("SCRIPT", "scripts/prefabs/player_common.lua"),
}

local prefabs =
{
}

local start_inv =
{

}

local function onbecamehuman(inst)
end

local function onbecameghost(inst)
	inst.AnimState:SetBuild("ghost_vader_build")
end

local function onload(inst)
	inst:ListenForEvent("ms_respawnedfromghost", onbecamehuman)
	inst:ListenForEvent("ms_becameghost", onbecameghost)
	
	if inst:HasTag("playerghost") then
		onbecameghost(inst)
	else
		onbecamehuman(inst)
	end
end

local function OnKeyPressed(inst, data)
	if data.inst == ThePlayer then
		if data.key == KEY_LALT then

			if TheWorld.ismastersim then
				BufferedAction(inst, inst, ACTIONS.CROWN):Do()
			else
				SendRPCToServer(RPC.DoWidgetButtonAction, ACTIONS.CROWN.code, inst, ACTIONS.CROWN.mod_name)
			end
	  
		end
	end
end

local function common_postinit(inst)
	inst:AddComponent("keyhandler_vader")
	inst.MiniMapEntity:SetIcon("vader.tex")
	inst:ListenForEvent("keypressed", OnKeyPressed)
end

local master_postinit = function(inst)

inst.entity:AddLight()
inst.Light:Enable(false)
inst.Light:SetRadius(.85)
inst.Light:SetFalloff(0.5)
inst.Light:SetIntensity(.1)
inst.Light:SetColour(255 / 255, 255 / 255, 236 / 255)

inst.OnLoad = onload
inst.soundsname = "wendy"
inst.AnimState:SetBuild("vader")
inst.components.sanity:SetMax(500)
inst.components.hunger:SetMax(500)
inst.components.health:SetMaxHealth(500)
inst.components.sanity.neg_aura_mult = 0
inst.components.sanity.night_drain_mult = 0
inst.components.combat.damagemultiplier = 1.5
STRINGS.CHARACTERS.vader = require "speech_vader"
inst.components.hunger.hungerrate = 5 * TUNING.WILSON_HUNGER_RATE
inst.components.locomotor.runspeed = 1.5 * TUNING.WILSON_RUN_SPEED

inst:ListenForEvent("onattackother", function(inst, data)
	if data.target:HasTag("shadow") or data.target:HasTag("shadowminion") or data.target:HasTag("shadowchesspiece") or data.target:HasTag("stalker") then return end -- Divine Wrath doesn't effect Shadow Creatures.
	
	local gay   = inst.components
	local fuck  = data.target.components
	local boobs = fuck.health.currenthealth * .2
	
	if inst.crown == true then -- Lose 20% of Health, Hunger, or Sanity in return for dealing 500 damage against an entity.
	
		if fuck.health.currenthealth >= 501 then
		
			if gay.sanity.current >= 100 then
				gay.sanity:DoDelta(-100)
			elseif gay.sanity.current <= 100 and gay.hunger.current >= 100 then
				gay.hunger:DoDelta(-100)
			elseif gay.sanity.current <= 100 and gay.hunger.current <= 100 and gay.health.currenthealth >= 100 then
				gay.health:DoDelta(-100)
			elseif gay.sanity.current <= 100 and gay.hunger.current <= 100 and gay.health.currenthealth <= 100 then
				return
			end
			SpawnPrefab("lightning").Transform:SetPosition(data.target.Transform:GetWorldPosition())
			fuck.combat:GetAttacked(inst, 500, nil)
			
		elseif fuck.health.currenthealth <= 501 then
		
			if gay.sanity.current >= boobs then
				gay.sanity:DoDelta(-fuck.health.currenthealth * .2)
			elseif gay.sanity.current <= boobs and gay.hunger.current >= boobs then
				gay.hunger:DoDelta(-fuck.health.currenthealth * .2)
			elseif gay.sanity.current <= boobs and gay.hunger.current <= boobs and gay.health.currenthealth >= boobs then
				gay.health:DoDelta(-fuck.health.currenthealth * .2)
			elseif gay.sanity.current <= boobs and gay.hunger.current <= boobs and gay.health.currenthealth <= boobs then
				return
			end
			SpawnPrefab("lightning").Transform:SetPosition(data.target.Transform:GetWorldPosition())
			fuck.combat:GetAttacked(inst, 500, nil)
			
		end
		
	end
	
end)

-- IKUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUU~!
inst:ListenForEvent("attacked", function(inst, data)
	local sexual_moans = { "Aahh~<3!", "Oohhh~<3!", "Hhaaa~<3!", "UHhhh~<3!", "Yaahh~<3!", "Uwaahh~<3!" }
	
	inst.components.talker:Say(sexual_moans[math.random(1,6)])
end)

end

return MakePlayerCharacter("vader", prefabs, assets, common_postinit, master_postinit, start_inv)