PrefabFiles = {
	"vader",
	"vader_none",
}

Assets = {
    Asset( "IMAGE", "images/saveslot_portraits/vader.tex" ),
    Asset( "ATLAS", "images/saveslot_portraits/vader.xml" ),

    Asset( "IMAGE", "images/selectscreen_portraits/vader.tex" ),
    Asset( "ATLAS", "images/selectscreen_portraits/vader.xml" ),
	
    Asset( "IMAGE", "images/selectscreen_portraits/vader_silho.tex" ),
    Asset( "ATLAS", "images/selectscreen_portraits/vader_silho.xml" ),

    Asset( "IMAGE", "bigportraits/vader.tex" ),
    Asset( "ATLAS", "bigportraits/vader.xml" ),
	
	Asset( "IMAGE", "images/map_icons/vader.tex" ),
	Asset( "ATLAS", "images/map_icons/vader.xml" ),
	
	Asset( "IMAGE", "images/avatars/avatar_vader.tex" ),
    Asset( "ATLAS", "images/avatars/avatar_vader.xml" ),
	
	Asset( "IMAGE", "images/avatars/avatar_ghost_vader.tex" ),
    Asset( "ATLAS", "images/avatars/avatar_ghost_vader.xml" ),
	
	Asset( "IMAGE", "images/avatars/self_inspect_vader.tex" ),
    Asset( "ATLAS", "images/avatars/self_inspect_vader.xml" ),
	
	Asset( "IMAGE", "images/names_vader.tex" ),
    Asset( "ATLAS", "images/names_vader.xml" ),
	
    Asset( "IMAGE", "bigportraits/vader_none.tex" ),
    Asset( "ATLAS", "bigportraits/vader_none.xml" ),
}

local TUNING  = GLOBAL.TUNING
local require = GLOBAL.require
local STRINGS = GLOBAL.STRINGS

STRINGS.CHARACTER_TITLES.vader = "The Queen"
STRINGS.CHARACTER_NAMES.vader = "Vader Eloha"
STRINGS.CHARACTER_DESCRIPTIONS.vader = "*Very powerful\n*Has nice boobs\n*Likes fried chicken"
STRINGS.CHARACTER_QUOTES.vader = "\"Bow down before me, maggot.\""

STRINGS.CHARACTERS.GENERIC.DESCRIBE.vader = 
{
GENERIC = "Boobs are good.",
ATTACKER = "%s looks shifty boobs...",
MURDERER = "Boobs murderer!",
REVIVER = "%s, friend of boobs.",
GHOST = "%s could some boobs.",
FIRESTARTER = "Burning that wasn't very boobs, %s.",
}

STRINGS.NAMES.vader = "Vader Eloha"
AddModCharacter("vader", "FEMALE")
AddMinimapAtlas("images/map_icons/vader.xml")

local CROWN = GLOBAL.Action()
CROWN.str = "Crown"
CROWN.id = "CROWN"
CROWN.fn = function(act)
	if act.target.crown == nil then
		act.target.crown = true
		act.target.Light:Enable(true)
		act.target.AnimState:SetHaunted(true)
		act.target.sg:GoToState("powerup")
		act.target.AnimState:PlayAnimation("item_hat")
		act.target.components.sanity.dapperness = -TUNING.DAPPERNESS_LARGE
		act.target.SoundEmitter:PlaySound("dontstarve/wilson/equip_item")
		act.target.AnimState:SetBuild("vader_crown")
		act.target.components.locomotor.runspeed = 2 * TUNING.WILSON_RUN_SPEED
	elseif act.target.crown == true then
		act.target.crown = nil
		act.target.Light:Enable(false)
		act.target.AnimState:SetHaunted(false)
		act.target.sg:GoToState("powerup")
		act.target.AnimState:PlayAnimation("item_hat")
		act.target.components.sanity.dapperness = 0
		act.target.AnimState:SetBuild("vader")
		act.target.components.locomotor.runspeed = 1.5 * TUNING.WILSON_RUN_SPEED
	end
end

AddAction(CROWN)






















--Gay?